package com.blackledge.david.game;

public class GameException extends Exception {
	public static final GameException ID_IN_USE = new GameException("Player Identification already in use");
	public static final GameException GAME_FULL = new GameException("Game is already Full");
	public static final GameException GAME_NOT_FOUND = new GameException("Game Not Found");
	
	public GameException(String message) {
		super(message);
	}

}
