package com.blackledge.david.html;

import java.awt.Color;

public class HTMLTableRow extends HTMLRow {
	public final String tableid;
	public boolean isWidthProcessed = false;
	public int height = -1;

	public HTMLTableRow(String currentTable) {
		this.tableid  = currentTable;
	}

	public HTMLTableCell getLastCell() {
//FIXME		if(cells.size() == 0) 
		for (int i = getHTMLChunks().size() - 1; i >= 0; --i) {
			if (getHTMLChunks().get(i) instanceof HTMLTableCell) {
				return (HTMLTableCell) (getHTMLChunks().get(i));
			}
		}
		return null;
	}
	
	public HTMLTableCell addCell(boolean header, int rowspan, int colspan, String width, String height, Color bgcolor, int bgposition, int bgrepeat, String bg) {
		HTMLTableCell cell = new HTMLTableCell(header, rowspan, colspan, width, 
//				bgcolor==null?this.bgcolor: //row bg is handled now, so don't double it here.
					bgcolor, bgposition, bgrepeat, bg);
		addRowHeight(height);
		getHTMLChunks().add(cell);
		return cell;
	}

	public void addRowHeight(String cellHeight) {
		if(cellHeight == null || cellHeight.trim().length() == 0) return;
		cellHeight = cellHeight.trim();
		Integer cellHei = HTMLParserCallback.getCSSLength(cellHeight);
		if(cellHei == null) return;
		if(cellHei > height) {
			height = cellHei;
			return;
		}
//		if(cellHeight.endsWith("%")) {
//			if(height.endsWith("%")) {
//				try {
//					height = Math.max(
//							Integer.parseInt(cellHeight.substring(0,
//									cellHeight.length() - 1).trim()),
//							Integer.parseInt(height.substring(0,
//									height.length() - 1).trim()))
//									+ "%";
//				} catch (Exception e) {
//				}
//			} else {
//				// just have percent win always
//				//FIXME really not ideal
//				height = cellHeight;
//			}
//		} else 
		
	}
}
