package com.blackledge.david.tivo;

import java.awt.Color;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

import com.tivo.hme.bananas.BApplication;
import com.tivo.hme.bananas.BScreen;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;

public class KeyCodes extends V49BApplication {
	
	/** set factory to report us as a V49 application */
	public static class KeyCodesFactory extends V49BApplicationFactory {}
	
	public static class ShowCodes extends BScreen {

		private BView _keypress;
		private BView _keyrepeat;
		private BView _keyrelease;
		private String _font;
		private Color _color;

		public ShowCodes(BApplication bapp) {
			super(bapp);

			
//			new BView(getNormal(), 100, 130, 600, 20).setResource(createText(createFont("10.ttf", 0x04, 15)//"10-15.font"
//					,Color.white, "10 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 150, 600, 20).setResource(createText(createFont("10.ttf", 0x08, 15)
//					,Color.white, "10bFont ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 170, 600, 20).setResource(createText("11-15.font"
//					,Color.white, "11 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 190, 600, 20).setResource(createText("12-15.font"
//					,Color.white, "12 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 210, 600, 20).setResource(createText("13-15.font"
//					,Color.white, "13 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 230, 600, 20).setResource(createText("14-15.font"
//					,Color.white, "14 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 250, 600, 20).setResource(createText("15-15.font"
//					,Color.white, "15 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 270, 600, 20).setResource(createText("16-15.font"
//					,Color.white, "16 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 290, 600, 20).setResource(createText("17-15.font"
//					,Color.white, "17 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 310, 600, 20).setResource(createText("18-15.font"
//					,Color.white, "18 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 330, 600, 20).setResource(createText("19-15.font"
//					,Color.white, "19 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
			
//			new BView(getNormal(), 100, 130, 600, 20).setResource(createText("10-15.font"
//					,Color.white, "10 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 150, 600, 20).setResource(createText("10-15-bold.font"
//					,Color.white, "10 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 170, 600, 20).setResource(createText("10-15-italic.font"
//					,Color.white, "10 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 190, 600, 20).setResource(createText("13-15.font"
//					,Color.white, "13 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 210, 600, 20).setResource(createText("13-15-bold.font"
//					,Color.white, "13 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 230, 600, 20).setResource(createText("13-15-italic.font"
//					,Color.white, "13 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 250, 600, 20).setResource(createText("14-15.font"
//					,Color.white, "14 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 270, 600, 20).setResource(createText("14-15-bold.font"
//					,Color.white, "14 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 290, 600, 20).setResource(createText("14-15-italic.font"
//					,Color.white, "14 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 310, 600, 20).setResource(createText("15-15.font"
//					,Color.white, "15 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 330, 600, 20).setResource(createText("15-15-bold.font"
//					,Color.white, "15 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 330, 600, 20).setResource(createText("15-15-italic.font"
//					,Color.white, "15 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 350, 600, 20).setResource(createText("11-15.font"
//					,Color.white, "11 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 370, 600, 20).setResource(createText("11-15-bold.font"
//					,Color.white, "11 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
//			new BView(getNormal(), 100, 390, 600, 20).setResource(createText("11-15-italic.font"
//					,Color.white, "11 Font ABCDEFGHIJKL abcdefghijkl 1234567890!@#$%^&*()"));
			
			BView keypress = new BView(getNormal(), 100, 100, (getWidth()-200)/3, 100
//					,false
					);
			keypress.setResource(createText("default-15.font",Color.white,"Key Press"));
			_keypress = new BView(getNormal(), 100, 100, (getWidth()-200)/3, getHeight()-200 
//					,false
					);
			
			BView keyrepeat = new BView(getNormal(), 100+_keypress.getWidth(), 100, (getWidth()-200)/3, 100
//					,false
					);
			keyrepeat.setResource(createText("default-15.font",Color.white,"Key Repeat"));
			_keyrepeat = new BView(getNormal(), 100+_keypress.getWidth(), 100, (getWidth()-200)/3, getHeight()-200
//					,false
					);
			
			BView keyrelease = new BView(getNormal(), 100+_keypress.getWidth()+_keyrepeat.getWidth(), 100, (getWidth()-200)/3, 100
//					,false
					);
			keyrelease.setResource(createText("default-15.font",Color.white,"Key Release"));
			_keyrelease = new BView(getNormal(), 100+_keypress.getWidth()+_keyrepeat.getWidth(), 100, (getWidth()-200)/3, getHeight()-200
//					,false
					);

			_font = "default-20.font";
			_color = Color.yellow;
		}
		
		@Override
		public boolean handleKeyPress(int code, long rawcode) {
			String text = getCodeText(code, rawcode);
			Resource res = _keypress.getResource();
			if(res != null) res.remove();
			_keypress.setResource(createText(_font, _color, text));
			
			return super.handleKeyPress(code, rawcode);
		}

		private String getCodeText(int code, long rawcode) {
			String keyName = "";
			try {
				Field[] fields = V49IHmeProtocol.class.getFields();
				for(Field f : fields) {
					int m = f.getModifiers();
					if(Modifier.isStatic(m) && Modifier.isPublic(m)) {
						if(f.getName().startsWith("KEY_") && f.getInt(null) == code) {
							keyName = f.getName();
							break;
						}
					}
				}
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if(keyName.length() == 0) {
				switch(code) {
				case 56: keyName = "KEY_OPT_A";
				break;
				case 57: keyName = "KEY_OPT_B";
				break;
				case 58: keyName = "KEY_OPT_C";
				break;
				case 59: keyName = "KEY_OPT_D";
				break;
//				Backspace is code 65
				case 65: keyName = "(Backspace)";
				break;
//				The enter key, when modified by the Alt or Windows key, is sent with code 70, otherwise it is sent as KEY_SELECT
				case 70: keyName = "(Alt/Win + Enter)";
				break;
//				Left Shift and Right Shift are codes 71 and 72
				case 71: keyName = "(Left Shift)";
				break;
				case 72: keyName = "(Right Shift)";
				break;
//				Left Alt and Right Alt (also Left and Right Windows key) 73 and 74
				case 73: keyName = "(Left Alt/Win)";
				break;
				case 74: keyName = "(Right Alt/Win)";
				break;
//				Capslock is code 75
				case 75: keyName = "(Capslock)";
				break;
				}
//				ASCII characters 32 (space) through (tilde (~)) come in with a key code equal to the ASCII code plus 2^16 (65536). In other words key code 65568 (space) through 65662 (tilde). This does not include the numbers which send standard HME KEY codes for the numbers.
				if(keyName.length() == 0 && code >= 65536 
//						+ ' ' && code <= 65536+'~'
						) {
					keyName = "(ASCII "+(code-65536)+" "+((char)code-65536)+" "+Character.getName(code-65536)+")";
				}
			}
			System.out.println(keyName+" "+code+" "+rawcode);
			return 
					"Code: "+code+" "+keyName+"\n"
					+
					"Rawcode: "+rawcode+"\n"
					;
		}

		@Override
		public boolean handleKeyRepeat(int code, long rawcode) {
			if(code == KEY_LEFT) getBApp().setActive(false);
			
			String text = getCodeText(code, rawcode);
			Resource res = _keyrepeat.getResource();
			if(res != null) res.remove();
			_keyrepeat.setResource(createText(_font, _color, text));
			return super.handleKeyRepeat(code, rawcode);
		}
		
		@Override
		public boolean handleKeyRelease(int code, long rawcode) {
			String text = getCodeText(code, rawcode);
			Resource res = _keyrelease.getResource();
			if(res != null) res.remove();
			_keyrelease.setResource(createText(_font, _color, text));
			return super.handleKeyRelease(code, rawcode);
		}
	}

	// /HME 1.4.1e

	@Override
	protected void showFirstPage() {
		push(new ShowCodes(this), TRANSITION_NONE);
	}
	

	@Override
	public void debug(String message) {
		System.out.println(message);
	}
	
	
}
